
package org.ow2.petals.bc.sftp.connection;

import java.io.IOException;
import java.util.logging.Logger;

import org.ow2.petals.bc.sftp.SFTPClientPool;

import com.sshtools.j2ssh.SftpClient;
import com.sshtools.j2ssh.SshClient;
import com.sshtools.j2ssh.transport.TransportProtocol;
import com.sshtools.j2ssh.transport.TransportProtocolEventHandler;

public class SftpClientWrapper implements TransportProtocolEventHandler {

    private SshClient sshClient;

    private SftpClient sftpClient;
    
    private Logger logger;

    public SftpClientWrapper(SshClient sshClient, Logger logger) {
        this.sshClient = sshClient;
        this.logger = logger;
    }

    public SftpClient getSftpClient() {
        return this.sftpClient;
    }

    public SshClient getSshClient() {
        return this.sshClient;
    }

    @Override
    public void onSocketTimeout(TransportProtocol arg0) {
        // force disconnect
        try {
            if (this.sftpClient != null) {
                this.sftpClient.quit();
            }
        } catch (IOException e) {
            //do nothing
        }
        this.sshClient.disconnect();
        this.sshClient = null;
        SFTPClientPool.cleanSFTPClient(this);
    }

    public void setSftpClient(SftpClient sftpClient) {
        this.sftpClient = sftpClient;
    }

    public void setSshClient(SshClient sshClient) {
        this.sshClient = sshClient;
    }

    @Override
    public void onDisconnect(TransportProtocol arg0) {
        this.logger.info(arg0.getUnderlyingProviderDetail() + " disconnected");
    }

}
